The Table Slicer relies on table, so you must add a table first if you want to create a slicer.
You can add a slicer by using the add method, as shown in the following code:
Slicer consists of a slicer header and a slicer body.
The slicer header is composed of slicer caption, multiSelect and clear filter button. The slicer caption is used to show a caption. The clear filter button is used to un-filter the slicer and it is inactive by default. It is active only when a slicer item is filtered .
The slicer body is composed of slicer items. There are four kinds of slicer items:
No Data Items: The items have been filtered out by another slicer.
Has Data Items: The items haven't been filtered out by another slicer.
Selected Items: The items have been filtered out by themselves.
Unselected Items: The items haven't been filtered out by themselves.
The items are divided into No Data Items and Has Data Items when they are filtered out by another slicer, or divided into Selected Items and Unselected Items when they are filtered out by themselves.
window.onload = function () {
_disableInput();
var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"));
spread.suspendPaint();
var sheet = spread.getActiveSheet();
var dataColumns = ["Name", "City", "Birthday", "Sex", "Weight", "Height"];
var data = [
["Bob", "NewYork", "1968/6/8", "man", "80", "180"],
["Betty", "NewYork", "1972/7/3", "woman", "72", "168"],
["Cherry", "Washington", "1986/2/2", "woman", "58", "161"],
["Gary", "NewYork", "1964/3/2", "man", "71", "179"],
["Hunk", "Washington", "1972/8/8", "man", "80", "171"],
["Eva", "Washington", "1993/2/15", "woman", "71", "180"]];
sheet.tables.addFromDataSource("table1", 1, 1, data);
sheet.getRange(-1, 1, -1, 6).width(80);
var table = sheet.tables.findByName("table1");
table.setColumnName(0, dataColumns[0]);
table.setColumnName(1, dataColumns[1]);
table.setColumnName(2, dataColumns[2]);
table.setColumnName(3, dataColumns[3]);
table.setColumnName(4, dataColumns[4]);
table.setColumnName(5, dataColumns[5]);
var slicer1 = sheet.slicers.add("slicer1", "table1", "Name");
slicer1.position(new GC.Spread.Sheets.Point(10, 170));
// show data items in original position
slicer1.showNoDataItemsInLast(false);
var slicer2 = sheet.slicers.add("slicer2", "table1", "City");
slicer2.position(new GC.Spread.Sheets.Point(220, 170));
var slicer3 = sheet.slicers.add("slicer3", "table1", "Height");
slicer3.position(new GC.Spread.Sheets.Point(430, 170));
// do not show filtered out items
slicer3.showNoDataItems(false);
bindSlicerEvent(spread);
spread.resumePaint();
// filter a city and show how other slicers' related data was effected
table.getSlicerData().doFilter("City", {exclusiveRowIndexes: [0]});
};
function bindSlicerEvent(spread) {
spread.bind(GC.Spread.Sheets.Events.SlicerChanged, function (event, args) {
var sheet = args.sheet;
var slicer = args.slicer;
if (!slicer) {
return;
}
var propertyName = args.propertyName;
if (propertyName === "isSelected") {
if (slicer.isSelected()) {
_activeInput();
var selectedSlicers = getSelectedSlicers(sheet);
if (selectedSlicers && selectedSlicers.length > 1) {
document.getElementById('slicer_name').disabled = true;
clearSlicerSetting();
}
else if (selectedSlicers.length === 1) {
initSlicerSetting(slicer);
}
}
else {
_disableInput();
}
}
});
var sheet = spread.getActiveSheet();
// slicer name
document.getElementById('slicer_name').oninput = function (e) {
var name = e.target.value;
if (!name) {
return;
}
var isSameName = isExistedName(sheet, name);
if (isSameName === true) {
alert("Duplicated slicer name.");
return;
}
else if (isSameName === false) {
setSlicerProperty({sheet: sheet}, "name", name);
}
};
// slicer caption name
document.getElementById('slicer_caption_name').oninput = function (e) {
setSlicerProperty({sheet: sheet}, "captionName", e.target.value);
}
// slicer header
document.getElementById('show_header').onchange = function (e) {
setSlicerProperty({sheet: sheet}, "showHeader", e.target.checked);
};
// slicer show no data items
document.getElementById('show_nodata_items').onchange = function (e) {
setSlicerProperty({sheet: sheet}, "showNoDataItems", e.target.checked);
};
// slicer show no data items last
document.getElementById('show_nodata_items_last').onchange = function (e) {
setSlicerProperty({sheet: sheet}, "showNoDataItemsInLast", e.target.checked);
};
// slicer visually no data items
document.getElementById('visually_nodata_items').onchange = function (e) {
setSlicerProperty({sheet: sheet}, "visuallyNoDataItems", e.target.checked);
};
}
function setSlicerProperty(data, property, value) {
var sheet = data && data.sheet;
if (!needChangeSlicer(sheet)) {
return;
}
var selectedSlicers = getSelectedSlicers(sheet);
for (var item in selectedSlicers) {
var slicer = selectedSlicers[item];
switch (property) {
case "name":
slicer.name(value);
break;
case "captionName":
slicer.captionName(value);
break;
case "showHeader":
slicer.showHeader(value);
break;
case "showNoDataItems":
slicer.showNoDataItems(value);
break;
case "showNoDataItemsInLast":
slicer.showNoDataItemsInLast(value);
break;
case "visuallyNoDataItems":
slicer.visuallyNoDataItems(value);
break;
}
}
}
function isExistedName(sheet, name) {
if (!sheet) {
return null;
}
var slicers = sheet.slicers.all();
if (!slicers || _isEmptyObject(slicers)) {
return null;
}
for (var item in slicers) {
var slicer = slicers[item];
if (!slicer.isSelected() && slicer.name() === name) {
return true;
}
}
return false;
}
function initSlicerSetting(slicer) {
document.getElementById('slicer_name').value = slicer.name();
document.getElementById('slicer_caption_name').value = slicer.captionName();
document.getElementById('show_header').checked = slicer.showHeader();
document.getElementById('show_nodata_items').checked = slicer.showNoDataItems();
document.getElementById('show_nodata_items_last').checked = slicer.showNoDataItemsInLast();
document.getElementById('visually_nodata_items').checked = slicer.visuallyNoDataItems();
}
function clearSlicerSetting() {
document.getElementById('slicer_name').value = "";
document.getElementById('slicer_caption_name').value = "";
document.getElementById('show_header').checked = false;
document.getElementById('show_nodata_items').checked = false;
document.getElementById('show_nodata_items_last').checked = false;
document.getElementById('visually_nodata_items').checked = false;
}
function getSelectedSlicers(sheet) {
if (!sheet) {
return null;
}
var slicers = sheet.slicers.all();
if (!slicers || _isEmptyObject(slicers)) {
return null;
}
var selectedSlicers = [];
for (var item in slicers) {
var slicer = slicers[item];
if (slicer.isSelected()) {
selectedSlicers.push(slicer);
}
}
return selectedSlicers;
}
function needChangeSlicer(sheet) {
if (!sheet) {
return false;
}
var selectedSlicers = getSelectedSlicers(sheet);
if (!selectedSlicers || selectedSlicers.length === 0) {
return false;
}
return true;
}
function _disableInput() {
var inputs = document.querySelectorAll('.option-row input');
for (var inputIndex = 0; inputIndex < inputs.length; inputIndex++) {
inputs[inputIndex].disabled = true;
}
}
function _activeInput() {
var inputs = document.querySelectorAll('.option-row input');
for (var inputIndex = 0; inputIndex < inputs.length; inputIndex++) {
inputs[inputIndex].disabled = false;
}
}
function _isEmptyObject(obj) {
var name;
for (name in obj) {
return false;
}
return true;
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-shapes/dist/gc.spread.sheets.shapes.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-slicers/dist/gc.spread.sheets.slicers.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
<div class="options-container">
<p style="padding:2px 10px; background-color:#F4F8EB">Select the slicer and then change the options.</p>
<div class="option-row">
<label for="slicer_name" style="display: inline-block;width: 150px">Name:</label>
<input type="text" id="slicer_name" />
</div>
<div class="option-row">
<label for="slicer_caption_name" style="display: inline-block;width: 150px">Caption Name:</label>
<input type="text" id="slicer_caption_name" />
</div>
<div class="option-row">
<input type="checkbox" id="show_header" checked />
<label for="show_header">ShowHeader</label>
</div>
<div class="option-row">
<input type="checkbox" id="show_nodata_items" checked />
<label for="show_nodata_items">ShowNoDataItems</label>
</div>
<div class="option-row">
<p class="desc">Check this box to show the unfiltered data items last in the slicer.</p>
<input type="checkbox" id="show_nodata_items_last" />
<label for="show_nodata_items_last">ShowNoDataItemsInLast</label>
<p style="padding:2px 10px; background-color:#F4F8EB">Check this box to gray out items that aren’t present in the table.</p>
<input type="checkbox" id="visually_nodata_items" checked />
<label for="visually_nodata_items">VisuallyNoDataItems</label>
</div>
</div>
</div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: auto;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-group {
margin-bottom: 6px;
}
label {
display: inline-block;
min-width: 90px;
margin: 6px 0;
}
input {
padding: 4px 6px;
box-sizing: border-box;
margin-bottom: 6px;
}
hr {
border-color: #fff;
opacity: .2;
margin: 12px 0;
}
p {
padding: 2px 10px;
background-color: #F4F8EB;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}

The Table Slicer relies on table, so you must add a table first if you want to create a slicer.
You can add a slicer by using the add method, as shown in the following code:
Slicer consists of a slicer header and a slicer body.
The slicer header is composed of slicer caption, multiSelect and clear filter button. The slicer caption is used to show a caption. The clear filter button is used to un-filter the slicer and it is inactive by default. It is active only when a slicer item is filtered .
The slicer body is composed of slicer items. There are four kinds of slicer items:
No Data Items: The items have been filtered out by another slicer.
Has Data Items: The items haven't been filtered out by another slicer.
Selected Items: The items have been filtered out by themselves.
Unselected Items: The items haven't been filtered out by themselves.
The items are divided into No Data Items and Has Data Items when they are filtered out by another slicer, or divided into Selected Items and Unselected Items when they are filtered out by themselves.
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-slicers";
import Panel from './panel';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
const { useState, useEffect } = React;
let selectedSlicersList = [];
let disableNameValue = true;
let nameValue = '';
let captionNameValue = '';
let showHeaderValue = true;
let showNoDataItemsValue = true;
let showNoDataItemsInLastValue = false;
let visuallyNoDataItemsValue = true;
let disableCaptionNameValue = true;
export const AppFunc = () => {
const [name, setName] = useState(nameValue);
const [captionName, setCaptionName] = useState(captionNameValue);
const [showHeader, setShowHeader] = useState(showHeaderValue);
const [showNoDataItems, setShowNoDataItems] = useState(showNoDataItemsValue);
const [showNoDataItemsInLast, setShowNoDataItemsInLast] = useState(showNoDataItemsInLastValue);
const [visuallyNoDataItems, setVisuallyNoDataItems] = useState(visuallyNoDataItemsValue);
const [disableName, setDisableName] = useState(disableNameValue);
const [disableCaptionName, setDisableCaptionName] = useState(disableCaptionNameValue);
useEffect(() => {
setNameToSpread(name);
}, [name]);
useEffect(() => {
setCaptionNameToSpread(captionName);
}, [captionName]);
useEffect(() => {
setShowHeaderToSpread(showHeader);
}, [showHeader]);
useEffect(() => {
setShowNoDataItemsToSpread(showNoDataItems);
}, [showNoDataItems]);
useEffect(() => {
setShowNoDataItemsInLastToSpread(showNoDataItemsInLast);
}, [showNoDataItemsInLast]);
useEffect(() => {
setVisuallyNoDataItemsToSpread(visuallyNoDataItems);
}, [visuallyNoDataItems]);
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread, setName, setCaptionName, setShowHeader, setShowNoDataItems, setShowNoDataItemsInLast, setVisuallyNoDataItems, setDisableName, setDisableCaptionName)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel
name={name}
captionName={captionName}
showHeader={showHeader}
showNoDataItems={showNoDataItems}
showNoDataItemsInLast={showNoDataItemsInLast}
visuallyNoDataItems={visuallyNoDataItems}
setName={setName}
disableName={disableName}
setDisableName={setDisableName}
disableCaptionName={disableCaptionName}
setDisableCaptionName={setDisableCaptionName}
setCaptionName={setCaptionName}
setShowHeader={setShowHeader}
setShowNoDataItems={setShowNoDataItems}
setShowNoDataItemsInLast={setShowNoDataItemsInLast}
setVisuallyNoDataItems={setVisuallyNoDataItems}
></Panel>
</div>
)
}
const setNameToSpread = (value) => {
if (!value) {
return;
}
nameValue = value;
selectedSlicersList.forEach((slicer) => {
slicer.name(value);
})
}
const setCaptionNameToSpread = (value) => {
captionNameValue = value;
selectedSlicersList.forEach((slicer) => {
slicer.captionName(value);
})
}
const setShowHeaderToSpread = (value) => {
showHeaderValue = value;
selectedSlicersList.forEach((slicer) => {
slicer.showHeader(value);
})
}
const setShowNoDataItemsToSpread = (value) => {
showNoDataItemsValue = value;
selectedSlicersList.forEach((slicer) => {
slicer.showNoDataItems(value);
})
}
const setShowNoDataItemsInLastToSpread = (value) => {
showNoDataItemsInLastValue = value;
selectedSlicersList.forEach((slicer) => {
slicer.showNoDataItemsInLast(value);
})
}
const setVisuallyNoDataItemsToSpread = (value) => {
visuallyNoDataItemsValue = value;
selectedSlicersList.forEach((slicer) => {
slicer.visuallyNoDataItems(value);
})
}
const bindEvent = (spread, ...fns) => {
spread.bind(GC.Spread.Sheets.Events.SlicerChanged, function (event, args) {
let sheet = args.sheet;
let slicer = args.slicer;
if (!slicer) {
return;
}
let propertyName = args.propertyName;
if (propertyName === "isSelected") {
if (slicer.isSelected()) {
disableCaptionNameValue = false;
selectedSlicersList = getSelectedSlicers(sheet);
if (selectedSlicersList && selectedSlicersList.length > 1) {
disableNameValue = true;
nameValue = '';
captionNameValue = '';
showHeaderValue = false;
showNoDataItemsValue = false;
showNoDataItemsInLastValue = false;
visuallyNoDataItemsValue = false;
}
else if (selectedSlicersList.length === 1) {
disableNameValue = false;
nameValue = slicer.name();
captionNameValue = slicer.captionName();
showHeaderValue = slicer.showHeader();
showNoDataItemsValue = slicer.showNoDataItems();
showNoDataItemsInLastValue = slicer.showNoDataItemsInLast();
visuallyNoDataItemsValue = slicer.visuallyNoDataItems();
}
}
else {
disableNameValue = true;
disableCaptionNameValue = true;
}
}
const [setName, setCaptionName, setShowHeader, setShowNoDataItems, setShowNoDataItemsInLast, setVisuallyNoDataItems, setDisableName, setDisableCaptionName] = fns;
setName(nameValue);
setDisableName(disableNameValue);
setDisableCaptionName(disableCaptionNameValue);
setCaptionName(captionNameValue);
setShowHeader(showHeaderValue);
setShowNoDataItems(showNoDataItemsValue);
setShowNoDataItemsInLast(showNoDataItemsInLastValue);
setVisuallyNoDataItems(visuallyNoDataItemsValue);
});
}
const getSelectedSlicers = (sheet) => {
if (!sheet) {
return null;
}
let slicers = sheet.slicers.all();
if (!slicers || _isEmptyObject(slicers)) {
return null;
}
let selectedSlicersList = [];
for (let item in slicers) {
let slicer = slicers[item];
if (slicer.isSelected()) {
selectedSlicersList.push(slicer);
}
}
return selectedSlicersList;
}
const _isEmptyObject = (obj) => {
for (let name in obj) {
return false;
}
return true;
}
const initSpread = (spread, ...args) => {
spread.suspendPaint();
let sheet = spread.getActiveSheet();
let dataColumns = ["Name", "City", "Birthday", "Sex", "Weight", "Height"];
let data = [
["Bob", "NewYork", "1968/6/8", "man", "80", "180"],
["Betty", "NewYork", "1972/7/3", "woman", "72", "168"],
["Cherry", "Washington", "1986/2/2", "woman", "58", "161"],
["Gary", "NewYork", "1964/3/2", "man", "71", "179"],
["Hunk", "Washington", "1972/8/8", "man", "80", "171"],
["Eva", "Washington", "1993/2/15", "woman", "71", "180"]];
sheet.tables.addFromDataSource("table1", 1, 1, data);
sheet.getRange(-1, 1, -1, 6).width(80);
let table = sheet.tables.findByName("table1");
table.setColumnName(0, dataColumns[0]);
table.setColumnName(1, dataColumns[1]);
table.setColumnName(2, dataColumns[2]);
table.setColumnName(3, dataColumns[3]);
table.setColumnName(4, dataColumns[4]);
table.setColumnName(5, dataColumns[5]);
let slicer1 = sheet.slicers.add("slicer1", "table1", "Name");
slicer1.position(new GC.Spread.Sheets.Point(10, 170));
// show data items in original position
slicer1.showNoDataItemsInLast(false);
let slicer2 = sheet.slicers.add("slicer2", "table1", "City");
slicer2.position(new GC.Spread.Sheets.Point(220, 170));
let slicer3 = sheet.slicers.add("slicer3", "table1", "Height");
slicer3.position(new GC.Spread.Sheets.Point(430, 170));
// do not show filtered out items
slicer3.showNoDataItems(false);
spread.resumePaint();
bindEvent(spread, ...args);
table.getSlicerData().doFilter("City", {exclusiveRowIndexes: [0]});
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet, Column } from '@mescius/spread-sheets-react';
import './styles.css';
import Panel from './panel';
const Component = React.Component;
const GCsheets = GC.Spread.Sheets;
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
// this.selectedSlicersList = [];
this.state = {
selectedSlicersList: [],
disableNameValue: true,
nameValue: '',
captionNameValue: '',
showHeaderValue: true,
showNoDataItemsValue: true,
showNoDataItemsInLastValue: false,
visuallyNoDataItemsValue: true,
disableCaptionNameValue: true
};
this.bindEvent = this.bindEvent.bind(this);
this.setName = this.setName.bind(this);
this.setDisableName = this.setDisableName.bind(this);
this.setDisableCaptionName = this.setDisableCaptionName.bind(this);
this.setCaptionName = this.setCaptionName.bind(this);
this.setShowHeader = this.setShowHeader.bind(this);
this.setShowNoDataItems = this.setShowNoDataItems.bind(this);
this.setShowNoDataItemsInLast = this.setShowNoDataItemsInLast.bind(this);
this.setVisuallyNoDataItems = this.setVisuallyNoDataItems.bind(this);
}
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel
name={this.state.nameValue}
captionName={this.state.captionNameValue}
showHeader={this.state.showHeaderValue}
showNoDataItems={this.state.showNoDataItemsValue}
showNoDataItemsInLast={this.state.showNoDataItemsInLastValue}
visuallyNoDataItems={this.state.visuallyNoDataItemsValue}
setName={this.setName}
disableName={this.state.disableNameValue}
setDisableName={this.setDisableName}
disableCaptionName={this.state.disableCaptionNameValue}
setDisableCaptionName={this.setDisableCaptionName}
setCaptionName={this.setCaptionName}
setShowHeader={this.setShowHeader}
setShowNoDataItems={this.setShowNoDataItems}
setShowNoDataItemsInLast={this.setShowNoDataItemsInLast}
setVisuallyNoDataItems={this.setVisuallyNoDataItems}
></Panel>
</div>
);
}
_isEmptyObject(obj) {
for (let name in obj) {
return false;
}
return true;
}
getSelectedSlicers(sheet) {
if (!sheet) {
return null;
}
let slicers = sheet.slicers.all();
if (!slicers || this._isEmptyObject(slicers)) {
return null;
}
let selectedSlicersList = [];
for (let item in slicers) {
let slicer = slicers[item];
if (slicer.isSelected()) {
selectedSlicersList.push(slicer);
}
}
return selectedSlicersList;
}
bindEvent(spread) {
let self = this;
spread.bind(GC.Spread.Sheets.Events.SlicerChanged, function (event, args) {
let sheet = args.sheet;
let slicer = args.slicer;
if (!slicer) {
return;
}
let propertyName = args.propertyName;
if (propertyName === "isSelected") {
if (slicer.isSelected()) {
// self.setState({ disableCaptionNameValue: false });
self.state.disableCaptionNameValue = false;
self.state.selectedSlicersList = self.getSelectedSlicers(sheet);
if (self.state.selectedSlicersList && self.state.selectedSlicersList.length > 1) {
self.setState({
disableNameValue: true,
nameValue: '',
captionNameValue: '',
showHeaderValue: false,
showNoDataItemsValue: false,
showNoDataItemsInLastValue: false,
visuallyNoDataItemsValue: false,
});
}
else if (self.state.selectedSlicersList.length === 1) {
self.setState({
disableNameValue: false,
nameValue: slicer.name(),
disableChangeSlicerOptions: false,
captionNameValue: slicer.captionName(),
showHeaderValue: slicer.showHeader(),
showNoDataItemsValue: slicer.showNoDataItems(),
showNoDataItemsInLastValue: slicer.showNoDataItemsInLast(),
visuallyNoDataItemsValue: slicer.visuallyNoDataItems(),
});
}
}
else {
self.setState({
disableNameValue: true,
disableCaptionNameValue: true
});
}
}
});
}
initSpread(spread) {
spread.suspendPaint();
let sheet = spread.getActiveSheet();
let dataColumns = ["Name", "City", "Birthday", "Sex", "Weight", "Height"];
let data = [
["Bob", "NewYork", "1968/6/8", "man", "80", "180"],
["Betty", "NewYork", "1972/7/3", "woman", "72", "168"],
["Cherry", "Washington", "1986/2/2", "woman", "58", "161"],
["Gary", "NewYork", "1964/3/2", "man", "71", "179"],
["Hunk", "Washington", "1972/8/8", "man", "80", "171"],
["Eva", "Washington", "1993/2/15", "woman", "71", "180"]];
sheet.tables.addFromDataSource("table1", 1, 1, data);
sheet.getRange(-1, 1, -1, 6).width(80);
let table = sheet.tables.findByName("table1");
table.setColumnName(0, dataColumns[0]);
table.setColumnName(1, dataColumns[1]);
table.setColumnName(2, dataColumns[2]);
table.setColumnName(3, dataColumns[3]);
table.setColumnName(4, dataColumns[4]);
table.setColumnName(5, dataColumns[5]);
let slicer1 = sheet.slicers.add("slicer1", "table1", "Name");
slicer1.position(new GC.Spread.Sheets.Point(10, 170));
// show data items in original position
slicer1.showNoDataItemsInLast(false);
let slicer2 = sheet.slicers.add("slicer2", "table1", "City");
slicer2.position(new GC.Spread.Sheets.Point(220, 170));
let slicer3 = sheet.slicers.add("slicer3", "table1", "Height");
slicer3.position(new GC.Spread.Sheets.Point(430, 170));
// do not show filtered out items
slicer3.showNoDataItems(false);
spread.resumePaint();
this.bindEvent(spread);
table.getSlicerData().doFilter("City", { exclusiveRowIndexes: [0] });
}
setName(nameValue) {
if (!nameValue) {
return;
}
this.state.selectedSlicersList.forEach((slicer) => {
slicer.name(nameValue);
})
this.setState({ nameValue: nameValue });
}
setDisableName(disableNameValue) {
this.setState({ disableNameValue: disableNameValue });
}
setDisableCaptionName(disableCaptionNameValue) {
this.setState({ disableCaptionNameValue: disableCaptionNameValue });
}
setCaptionName(captionNameValue) {
this.state.selectedSlicersList.forEach((slicer) => {
slicer.captionName(captionNameValue);
})
this.setState({ captionNameValue: captionNameValue });
}
setShowHeader(showHeaderValue) {
this.state.selectedSlicersList.forEach((slicer) => {
slicer.showHeader(showHeaderValue);
})
this.setState({ showHeaderValue: showHeaderValue });
}
setShowNoDataItems(showNoDataItemsValue) {
this.state.selectedSlicersList.forEach((slicer) => {
slicer.showNoDataItems(showNoDataItemsValue);
})
this.setState({ showNoDataItemsValue: showNoDataItemsValue });
}
setShowNoDataItemsInLast(showNoDataItemsInLastValue) {
this.state.selectedSlicersList.forEach((slicer) => {
slicer.showNoDataItemsInLast(showNoDataItemsInLastValue);
})
this.setState({ showNoDataItemsInLastValue: showNoDataItemsInLastValue });
}
setVisuallyNoDataItems(visuallyNoDataItemsValue) {
this.state.selectedSlicersList.forEach((slicer) => {
slicer.visuallyNoDataItems(visuallyNoDataItemsValue);
})
this.setState({ visuallyNoDataItemsValue: visuallyNoDataItemsValue });
}
}
import * as React from 'react';
export default function Panel(props) {
const { name,
captionName,
showHeader,
showNoDataItems,
showNoDataItemsInLast,
visuallyNoDataItems,
setName,
setCaptionName,
setShowHeader,
setShowNoDataItems,
setShowNoDataItemsInLast,
setVisuallyNoDataItems,
disableName,
disableCaptionName,
} = props;
return (
<div class="options-container">
<p style={{ padding: '2px 10px', backgroundColor: '#F4F8EB' }}>Select the slicer and then change the options.</p>
<div class="option-row">
<label for="slicer_name" style={{ display: 'inline-block', width: '150px' }} >Name:</label>
<input type="text" id="slicer_name" disabled={disableName} value={name} onChange={(e) => { setName(e.target.value) }} />
</div>
<div class="option-row">
<label for="slicer_caption_name" style={{ display: 'inline-block', width: '150px' }}>Caption Name:</label>
<input type="text" id="slicer_caption_name" disabled={disableCaptionName} value={captionName} onChange={(e) => { setCaptionName(e.target.value) }} />
</div>
<div class="option-row">
<input type="checkbox" id="show_header" disabled={disableCaptionName} checked={showHeader} onChange={(e) => { setShowHeader(e.target.checked) }} />
<label for="show_header">ShowHeader</label>
</div>
<div class="option-row">
<input type="checkbox" id="show_nodata_items" disabled={disableCaptionName} checked={showNoDataItems} onChange={(e) => { setShowNoDataItems(e.target.checked) }} />
<label for="show_nodata_items">ShowNoDataItems</label>
</div>
<div class="option-row">
<p class="desc">Check this box to show the unfiltered data items last in the slicer.</p>
<input type="checkbox" id="show_nodata_items_last" disabled={disableCaptionName} checked={showNoDataItemsInLast} onChange={(e) => { setShowNoDataItemsInLast(e.target.checked) }} />
<label for="show_nodata_items_last">ShowNoDataItemsInLast</label>
<p style={{ padding: '2px 10px', backgroundColor: '#F4F8EB' }}>Check this box to gray out items that aren’t present in the table.</p>
<input type="checkbox" id="visually_nodata_items" disabled={disableCaptionName} checked={visuallyNoDataItems} onChange={(e) => { setVisuallyNoDataItems(e.target.checked) }} />
<label for="visually_nodata_items">VisuallyNoDataItems</label>
</div>
</div>
);
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: auto;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-group {
margin-bottom: 6px;
}
label {
display: inline-block;
min-width: 90px;
margin: 6px 0;
}
input {
padding: 4px 6px;
box-sizing: border-box;
margin-bottom: 6px;
}
hr {
border-color: #fff;
opacity: .2;
margin: 12px 0;
}
p {
padding: 2px 10px;
background-color: #F4F8EB;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.5-master-2026-07-21-2132/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'cdn:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-slicers': 'cdn:@mescius/spread-sheets-slicers/index.js',
'@mescius/spread-sheets-react': 'cdn:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

The Table Slicer relies on table, so you must add a table first if you want to create a slicer.
You can add a slicer by using the add method, as shown in the following code:
Slicer consists of a slicer header and a slicer body.
The slicer header is composed of slicer caption, multiSelect and clear filter button. The slicer caption is used to show a caption. The clear filter button is used to un-filter the slicer and it is inactive by default. It is active only when a slicer item is filtered .
The slicer body is composed of slicer items. There are four kinds of slicer items:
No Data Items: The items have been filtered out by another slicer.
Has Data Items: The items haven't been filtered out by another slicer.
Selected Items: The items have been filtered out by themselves.
Unselected Items: The items haven't been filtered out by themselves.
The items are divided into No Data Items and Has Data Items when they are filtered out by another slicer, or divided into Selected Items and Unselected Items when they are filtered out by themselves.
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-slicers";
import './styles.css';
const getSelectedSlicers = (sheet: GC.Spread.Sheets.Worksheet) => {
if (!sheet) {
return null;
}
let slicers = sheet.slicers.all();
if (!slicers || _isEmptyObject(slicers)) {
return null;
}
let selectedSlicersList = [];
for (let item in slicers) {
let slicer = slicers[item];
if (slicer.isSelected()) {
selectedSlicersList.push(slicer);
}
}
return selectedSlicersList;
}
const _isEmptyObject = (obj: object) => {
for (let name in obj) {
return false;
}
return true;
}
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
name = '';
captionName = '';
showHeader = true;
showNoDataItems = true;
showNoDataItemsInLast = false;
visuallyNoDataItems = true;
disableName = true;
disableCaptionName = true;
selectedSlicersList: any[] = [];
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
updateName() {
if (!this.name) {
return;
}
this.selectedSlicersList.forEach((slicer) => {
slicer.name(this.name);
})
}
updateCaptionName() {
this.selectedSlicersList.forEach((slicer) => {
slicer.captionName(this.captionName);
})
}
updateShowHeader() {
this.selectedSlicersList.forEach((slicer) => {
slicer.showHeader(this.showHeader);
})
}
updateShowNoDataItems() {
this.selectedSlicersList.forEach((slicer) => {
slicer.showNoDataItems(this.showNoDataItems);
})
}
updateShowNoDataItemsInLast() {
this.selectedSlicersList.forEach((slicer) => {
slicer.showNoDataItemsInLast(this.showNoDataItemsInLast);
})
}
updateVisuallyNoDataItems() {
this.selectedSlicersList.forEach((slicer) => {
slicer.visuallyNoDataItems(this.visuallyNoDataItems);
})
}
initSpread($event: any) {
let spread = this.spread = $event.spread;
spread.suspendPaint();
let sheet = spread.getActiveSheet();
let dataColumns = ["Name", "City", "Birthday", "Sex", "Weight", "Height"];
let data = [
["Bob", "NewYork", "1968/6/8", "man", "80", "180"],
["Betty", "NewYork", "1972/7/3", "woman", "72", "168"],
["Cherry", "Washington", "1986/2/2", "woman", "58", "161"],
["Gary", "NewYork", "1964/3/2", "man", "71", "179"],
["Hunk", "Washington", "1972/8/8", "man", "80", "171"],
["Eva", "Washington", "1993/2/15", "woman", "71", "180"]
];
sheet.tables.addFromDataSource("table1", 1, 1, data);
sheet.getRange(-1, 1, -1, 6).width(80);
let table = sheet.tables.findByName("table1");
table.setColumnName(0, dataColumns[0]);
table.setColumnName(1, dataColumns[1]);
table.setColumnName(2, dataColumns[2]);
table.setColumnName(3, dataColumns[3]);
table.setColumnName(4, dataColumns[4]);
table.setColumnName(5, dataColumns[5]);
let slicer1 = sheet.slicers.add("slicer1", "table1", "Name");
slicer1.position(new GC.Spread.Sheets.Point(10, 170));
// show data items in original position
slicer1.showNoDataItemsInLast(false);
let slicer2 = sheet.slicers.add("slicer2", "table1", "City");
slicer2.position(new GC.Spread.Sheets.Point(220, 170));
let slicer3 = sheet.slicers.add("slicer3", "table1", "Height");
slicer3.position(new GC.Spread.Sheets.Point(430, 170));
// do not show filtered out items
slicer3.showNoDataItems(false);
spread.resumePaint();
this.bindEvent(spread);
table.getSlicerData().doFilter("City", {exclusiveRowIndexes: [0]});
}
bindEvent(spread: GC.Spread.Sheets.Workbook) {
let self = this;
spread.bind(GC.Spread.Sheets.Events.SlicerChanged, function(event: any, args: any) {
let sheet = args.sheet;
let slicer = args.slicer;
if (!slicer) {
return;
}
let propertyName = args.propertyName;
if (propertyName === "isSelected") {
if (slicer.isSelected()) {
self.disableCaptionName = false;
self.selectedSlicersList = getSelectedSlicers(sheet);
if (self.selectedSlicersList && self.selectedSlicersList.length > 1) {
self.disableName = true;
self.name = '';
self.captionName = '';
self.showHeader = false;
self.showNoDataItems = false;
self.showNoDataItemsInLast = false;
self.visuallyNoDataItems = false;
} else if (self.selectedSlicersList.length === 1) {
self.disableName = false;
self.name = slicer.name();
self.captionName = slicer.captionName();
self.showHeader = slicer.showHeader();
self.showNoDataItems = slicer.showNoDataItems();
self.showNoDataItemsInLast = slicer.showNoDataItemsInLast();
self.visuallyNoDataItems = slicer.visuallyNoDataItems();
}
} else {
self.disableName = true;
self.disableCaptionName = true;
}
}
});
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
</gc-spread-sheets>
<div class="options-container">
<p style="padding:2px 10px; background-color:#F4F8EB">Select the slicer and then change the options.</p>
<div class="option-row">
<label for="slicer_name" style="display: inline-block;width: 150px">Name:</label>
<input type="text" id="slicer_name" [disabled]="disableName" [(ngModel)]="name" (change)="updateName()" />
</div>
<div class="option-row">
<label for="slicer_caption_name" style="display: inline-block;width: 150px">Caption Name:</label>
<input type="text" id="slicer_caption_name" [disabled]="disableCaptionName" [(ngModel)]="captionName" (change)="updateCaptionName()" />
</div>
<div class="option-row">
<input type="checkbox" id="show_header" [disabled]="disableCaptionName" [(ngModel)]="showHeader" (change)="updateShowHeader()"/>
<label for="show_header">ShowHeader</label>
</div>
<div class="option-row">
<input type="checkbox" id="show_nodata_items" [disabled]="disableCaptionName" [(ngModel)]="showNoDataItems" (change)="updateShowNoDataItems()" />
<label for="show_nodata_items">ShowNoDataItems</label>
</div>
<div class="option-row">
<p class="desc">Check this box to show the unfiltered data items last in the slicer.</p>
<input type="checkbox" id="show_nodata_items_last" [disabled]="disableCaptionName" [(ngModel)]="showNoDataItemsInLast" (change)="updateShowNoDataItemsInLast()" />
<label for="show_nodata_items_last">ShowNoDataItemsInLast</label>
<p style="padding:2px 10px; background-color:#F4F8EB">Check this box to gray out items that aren’t present in the table.</p>
<input type="checkbox" id="visually_nodata_items" [disabled]="disableCaptionName" [(ngModel)]="visuallyNoDataItems" (change)="updateVisuallyNoDataItems()" />
<label for="visually_nodata_items">VisuallyNoDataItems</label>
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: auto;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-group {
margin-bottom: 6px;
}
label {
display: inline-block;
min-width: 90px;
margin: 6px 0;
}
input {
padding: 4px 6px;
box-sizing: border-box;
margin-bottom: 6px;
}
hr {
border-color: #fff;
opacity: .2;
margin: 12px 0;
}
p {
padding: 2px 10px;
background-color: #F4F8EB;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.5-master-2026-07-21-2132/'
},
// map tells the System loader where to look for things
map: {
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'cdn:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-slicers': 'cdn:@mescius/spread-sheets-slicers/index.js',
'@mescius/spread-sheets-angular': 'cdn:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

The Table Slicer relies on table, so you must add a table first if you want to create a slicer.
You can add a slicer by using the add method, as shown in the following code:
Slicer consists of a slicer header and a slicer body.
The slicer header is composed of slicer caption, multiSelect and clear filter button. The slicer caption is used to show a caption. The clear filter button is used to un-filter the slicer and it is inactive by default. It is active only when a slicer item is filtered .
The slicer body is composed of slicer items. There are four kinds of slicer items:
No Data Items: The items have been filtered out by another slicer.
Has Data Items: The items haven't been filtered out by another slicer.
Selected Items: The items have been filtered out by themselves.
Unselected Items: The items haven't been filtered out by themselves.
The items are divided into No Data Items and Has Data Items when they are filtered out by another slicer, or divided into Selected Items and Unselected Items when they are filtered out by themselves.
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
</gc-spread-sheets>
<div class="options-container">
<p style="padding:2px 10px; background-color:#F4F8EB">Select the slicer and then change the options.</p>
<div class="option-row">
<label for="slicer_name" style="display: inline-block;width: 150px">Name:</label>
<input type="text" id="slicer_name" :disabled="disableName" v-model="name" @change="updateName" />
</div>
<div class="option-row">
<label for="slicer_caption_name" style="display: inline-block;width: 150px">Caption Name:</label>
<input type="text" id="slicer_caption_name" :disabled="disableCaptionName" v-model="captionName"
@change="updateCaptionName" />
</div>
<div class="option-row">
<input type="checkbox" id="show_header" :disabled="disableCaptionName" v-model="showHeader"
@change="updateShowHeader" />
<label for="show_header">ShowHeader</label>
</div>
<div class="option-row">
<input type="checkbox" id="show_nodata_items" :disabled="disableCaptionName" checked v-model="showNoDataItems"
@change="updateShowNoDataItems" />
<label for="show_nodata_items">ShowNoDataItems</label>
</div>
<div class="option-row">
<p class="desc">Check this box to show the unfiltered data items last in the slicer.</p>
<input type="checkbox" id="show_nodata_items_last" :disabled="disableCaptionName"
v-model="showNoDataItemsInLast" @change="updateShowNoDataItemsInLast" />
<label for="show_nodata_items_last">ShowNoDataItemsInLast</label>
<p style="padding:2px 10px; background-color:#F4F8EB">Check this box to gray out items that aren’t present in
the table.</p>
<input type="checkbox" id="visually_nodata_items" :disabled="disableCaptionName" v-model="visuallyNoDataItems"
@change="updateVisuallyNoDataItems" />
<label for="visually_nodata_items">VisuallyNoDataItems</label>
</div>
</div>
</div>
</template>
<script setup>
import '@mescius/spread-sheets-vue';
import '@mescius/spread-sheets-slicers';
import { ref } from "vue";
import GC from "@mescius/spread-sheets";
const spreadRef = ref(null);
const name = ref('');
const captionName = ref('');
const showHeader = ref(true);
const showNoDataItems = ref(true);
const showNoDataItemsInLast = ref(false);
const visuallyNoDataItems = ref(true);
const disableName = ref(true);
const disableCaptionName = ref(true);
const selectedSlicersList = ref([]);
const GCsheets = GC.Spread.Sheets;
const getSelectedSlicers = (sheet) => {
if (!sheet) {
return null;
}
let slicers = sheet.slicers.all();
if (!slicers || _isEmptyObject(slicers)) {
return null;
}
let selectedSlicersList = [];
for (let item in slicers) {
let slicer = slicers[item];
if (slicer.isSelected()) {
selectedSlicersList.push(slicer);
}
}
return selectedSlicersList;
}
const _isEmptyObject = (obj) => {
for (let name in obj) {
return false;
}
return true;
}
const updateName = () => {
if (!name.value) {
return;
}
selectedSlicersList.value.forEach((slicer) => {
slicer.name(name.value);
})
}
const updateCaptionName = () => {
selectedSlicersList.value.forEach((slicer) => {
slicer.captionName(captionName.value);
})
}
const updateShowHeader = () => {
selectedSlicersList.value.forEach((slicer) => {
slicer.showHeader(showHeader.value);
})
}
const updateShowNoDataItems = () => {
selectedSlicersList.value.forEach((slicer) => {
slicer.showNoDataItems(showNoDataItems.value);
})
}
const updateShowNoDataItemsInLast = () => {
selectedSlicersList.value.forEach((slicer) => {
slicer.showNoDataItemsInLast(showNoDataItemsInLast.value);
})
}
const updateVisuallyNoDataItems = () => {
selectedSlicersList.value.forEach((slicer) => {
slicer.visuallyNoDataItems(visuallyNoDataItems.value);
})
}
const initSpread = (spread) => {
spread.suspendPaint();
let sheet = spread.getActiveSheet();
let dataColumns = ["Name", "City", "Birthday", "Sex", "Weight", "Height"];
let data = [
["Bob", "NewYork", "1968/6/8", "man", "80", "180"],
["Betty", "NewYork", "1972/7/3", "woman", "72", "168"],
["Cherry", "Washington", "1986/2/2", "woman", "58", "161"],
["Gary", "NewYork", "1964/3/2", "man", "71", "179"],
["Hunk", "Washington", "1972/8/8", "man", "80", "171"],
["Eva", "Washington", "1993/2/15", "woman", "71", "180"]
];
sheet.tables.addFromDataSource("table1", 1, 1, data);
sheet.getRange(-1, 1, -1, 6).width(80);
let table = sheet.tables.findByName("table1");
table.setColumnName(0, dataColumns[0]);
table.setColumnName(1, dataColumns[1]);
table.setColumnName(2, dataColumns[2]);
table.setColumnName(3, dataColumns[3]);
table.setColumnName(4, dataColumns[4]);
table.setColumnName(5, dataColumns[5]);
let slicer1 = sheet.slicers.add("slicer1", "table1", "Name");
slicer1.position(new GC.Spread.Sheets.Point(10, 170));
// show data items in original position
slicer1.showNoDataItemsInLast(false);
let slicer2 = sheet.slicers.add("slicer2", "table1", "City");
slicer2.position(new GC.Spread.Sheets.Point(220, 170));
let slicer3 = sheet.slicers.add("slicer3", "table1", "Height");
slicer3.position(new GC.Spread.Sheets.Point(430, 170));
// do not show filtered out items
slicer3.showNoDataItems(false);
spread.resumePaint();
bindEvent(spread);
table.getSlicerData().doFilter("City", { exclusiveRowIndexes: [0] });
}
const bindEvent = (spread) => {
spread.bind(GC.Spread.Sheets.Events.SlicerChanged, function (event, args) {
let sheet = args.sheet;
let slicer = args.slicer;
if (!slicer) {
return;
}
let propertyName = args.propertyName;
if (propertyName === "isSelected") {
if (slicer.isSelected()) {
disableCaptionName.value = false;
selectedSlicersList.value = getSelectedSlicers(sheet);
if (selectedSlicersList.value && selectedSlicersList.value.length > 1) {
disableName.value = true;
name.value = '';
captionName.value = '';
showHeader.value = false;
showNoDataItems.value = false;
showNoDataItemsInLast.value = false;
visuallyNoDataItems.value = false;
} else if (selectedSlicersList.value.length === 1) {
disableName.value = false;
name.value = slicer.name();
captionName.value = slicer.captionName();
showHeader.value = slicer.showHeader();
showNoDataItems.value = slicer.showNoDataItems();
showNoDataItemsInLast.value = slicer.showNoDataItemsInLast();
visuallyNoDataItems.value = slicer.visuallyNoDataItems();
}
} else {
disableName.value = true;
disableCaptionName.value = true;
}
}
});
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: auto;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-group {
margin-bottom: 6px;
}
label {
display: inline-block;
min-width: 90px;
margin: 6px 0;
}
input {
padding: 4px 6px;
box-sizing: border-box;
margin-bottom: 6px;
}
hr {
border-color: #fff;
opacity: .2;
margin: 12px 0;
}
p {
padding: 2px 10px;
background-color: #F4F8EB;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.5-master-2026-07-21-2132/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'cdn:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-slicers': 'cdn:@mescius/spread-sheets-slicers/index.js',
'@mescius/spread-sheets-vue': 'cdn:@mescius/spread-sheets-vue/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);